# Ctrl IDE

A keyboard driven IDE in your terminal, the unix way.

```txt
,---,---,---,---,---,---,---,---,---,---,---,---,---,-------,
|   |   |   |   |   |   |   |   |   |   |   | [ | ] | <-    |
|---'-,-'-,-'-,-'-,-'-,-'-,-'-,-'-,-'-,-'-,-'-,-'-,-'-,-----|
| ->| |   |   |   |   |   |   |   |   |   |   | [ | ] |  \  |
|-----',--',--',--',--',--',--',--',--',--',--',--',--'-----|
| Caps |   |   | C | T | R | L |   |   |   | ; | ' |  Enter |
|------'-,-'-,-'-,-'-,-'-,-'-,-'-,-'-,-'-,-'-,-'-,-'--------|
|        |   |   |   |   |   |   |   | , | . | / |          |
|------,-',--'--,'---'---'---'---'---'---'-,-'---',--,------|
| ctrl |  | alt |                          | alt  |  | ctrl |
'------'  '-----'--------------------------'------'  '------'
```

## Primary tools used

- [Nushell](https://www.nushell.sh) -> Shell
- [Yazi](https://yazi-rs.github.io) -> File explorer (Sidebar)
- [Helix editor](https://helix-editor.com) -> Code editor
- [Zellij](https://zellij.dev) -> Session/Project management
- [Lazygit](https://github.com/jesseduffield/lazygit) -> Git terminal user interface

## Inspiration

### Design

- Catppuccin

### IDE/Code editor

- Jetbrain's IDE

## Thanks to

### Design

- Nieminen Mika for the ascii art
- Catppuccin

### Language servers

- [efm-langserver](https://github.com/mattn/efm-langserver/) -> External linters and formating support
- [simple-completion-language-server](https://github.com/estin/simple-completion-language-server) -> Snippet support
